/**
 * Die Klasse HauptMenue gehoehrt natuerlich ebenfalls zum Package Grafische-
 * Oberflaeche. Hier werden die einzelnen Menue Punkte erstellt. Da im Menue
 * Punkt Programm manche Schalter aktiviert und deaktiviert werden, wird der
 * Name im Kopf des Programms bekannt gemacht und deshalb sind die Namen auch
 * unterschiedlich. Der ActionListener wird aus der Klasse GrafischeOber-
 * flaeche uebergeben, damit die Aktionen sozusagen synchronisiert werden.
 * @author Alexander Schneider, Christian Ongyert, Tobias Kieninger
*/

package GrafischeOberflaeche;

import java.awt.*;
import java.awt.event.*;

public class HauptMenue
  extends MenuBar
{
  protected Menu MenueProgramm;

  public HauptMenue(ActionListener listener)
  {
    MenueProgramm=new Menu("Programm");
    MenueProgramm.add(new MenuItem("Starten"));
    MenueProgramm.add(new MenuItem("Stop"));
    MenueProgramm.add(new MenuItem("Lschen"));
    MenueProgramm.addSeparator();
    MenueProgramm.add(new MenuItem("Beenden"));
    MenueProgramm.addActionListener(listener);
    add(MenueProgramm);

    Menu MenueSchriftart;
    MenueSchriftart=new Menu("Schriftart");
    MenueSchriftart.add(new MenuItem("Grafik"));
    MenueSchriftart.add(new MenuItem("Menues"));
    MenueSchriftart.add(new MenuItem("TextArea"));
    MenueSchriftart.addActionListener(listener);
    add(MenueSchriftart);

    Menu MenueHilfe;
    MenueHilfe=new Menu("Hilfe");
    MenueHilfe.add(new MenuItem("Hilfe"));
    MenueHilfe.add(new MenuItem("Info"));
    MenueHilfe.addActionListener(listener);
    add(MenueHilfe);
  }
}
