/**
 * Die Klasse Maschine ist die Oberklasse der Maschinen. Hier werden die
 * Methoden Eingang und Bearbeiten praktisch bekannt gemacht.
 * @author Alexander Schneider, Christian Ongyert, Tobias Kieninger
*/

package Steuerung;

import java.awt.*;
import GrafischeOberflaeche.*;

public abstract class Maschine extends Fertigungsmodul
{
  public Maschine(Fertigungsmodul _Nachfolger1,Werkstueck _Rohling,TextArea _TextAusgabe,
                  Grafik _zeichnen,Delay _Warten,String _Name,int _Schriftgroesse)
  {
    super(_Nachfolger1,_Rohling,_TextAusgabe,_zeichnen,_Warten,_Name,_Schriftgroesse);
  }

/**
 * Die draw-Methode zeichnet die Maschinen. Man haette diese Methode in Fertigungs-
 * modul implementieren koennen, jedoch sollen sich die einzelnen Module selber zeichnen.
 * So mu man eben in jedem Modul die draw-Methode implementieren. Sie bekommt die
 * x-Position, y-Position, weite und hoehe uebergeben.
 */

  public void draw(int xPos,int yPos,int width,int height,Graphics Grafik)
  {
    if (inArbeit) 
    {
      Grafik.setColor(new Color(255,0,0));
      Grafik.fillRect(xPos,yPos,width,height);
      Grafik.setColor(new Color(0,0,0));
    }
    Grafik.drawRect(xPos,yPos,width,height);
    int StringPosX=xPos+3;
    int StringPosY=yPos+Schriftgroesse+3;
    Grafik.drawString(Name,StringPosX,StringPosY);
  }

  protected abstract void Ausgang(Fertigungsmodul _Mat);

  protected abstract void Bearbeiten();
}
